<template>
  <div>
    <div class="h1 mb-5">Treatment Summary</div>
    <div class="bg-white rounded-lg px-4 mb-5">
      <div class="item">
        <div class="text-sm">Physician Consultation</div>
        <div class="flex">
          <p class="old-price">$150</p>
          <p class="price">FREE</p>
        </div>
      </div>
      <div class="item">
        <div class="text-sm">Unlimited Follow-Ups</div>
        <div class="flex">
          <p class="old-price">$200</p>
          <p class="price">FREE</p>
        </div>
      </div>
      <div class="item">
        <div class="flex items-center">
          <img class="mr-5" src="@/assets/img/misc/bottle.png" width="20px" alt="bottle">
          <div class="pr-5">
            <p class="font-semibold mb-1">
              {{ userFirstName }}’s Personalized {{ selectedTreatment }} Treatment
            </p>
            <p class="text-sm text-grey-medium-2">
              Ships every 2 months
            </p>
          </div>
        </div>
        <div>$87.99</div>
      </div>
      <div class="item" v-if="appliedPromo">
        <div class="text-sm">Discount</div>
        <div>-$10.00</div>
      </div>
      <div class="item">
        <div class="text-sm">Unlimited Follow-Ups</div>
        <div class="flex">
          <p class="old-price">$15</p>
          <p class="price">FREE</p>
        </div>
      </div>
      <div class="item">
        <div>Unlimited Follow-Ups</div>
        <div class="flex">
          <p class="old-price">$452.99</p>
          <p class="price">
            {{ appliedPromo ? '$87.99' : '$77.99' }}
          </p>
        </div>
      </div>
    </div>
    <div class="bg-white rounded-lg p-5 mb-5 relative">
      <div
        class="underline text-grey-dark cursor-pointer"
        @click="isEnteringPromo = true"
        v-if="!isEnteringPromo && !appliedPromo"
      >
        Apply a promo code
      </div>
      <div
        v-else-if="isEnteringPromo && !appliedPromo"
        class="flex justify-between"
      >
        <div class="absolute left-5 top-3 text-xs text-grey-dark">Apply a promo code</div>
        <input v-model="enteredPromo" type="text" class="relative top-2 mr-6 flex-auto">
        <div
          class="px-5 py-2 rounded-lg cursor-pointer border border-green-light-2"
          @click="applyPromo"
        >
          Apply
        </div>
      </div>
      <div
        v-if="appliedPromo"
        class="flex items-center justify-between"
      >
        <div class="text-green-black">{{ appliedPromo }} has been applied</div>
        <div
          class="underline cursor-pointer text-grey-dark"
          @click="appliedPromo = null"
        >
          Remove
        </div>
      </div>
    </div>
    <div class="form mb-6">
      <div class="flex items-center py-5">
        <div
          v-if="currentStage === 1"
          class="mr-3 text-sm font-semibold text-white flex items-center justify-center w-6 h-6 rounded-full bg-green-n-black">
          1
        </div>
        <img class="mr-3" v-else src="@/assets/img/icons/check.png" width="22px" alt="success">
        <div class="font-semibold">Add Shipping Information</div>
      </div>
      <div
        v-if="currentStage === 1"
        class="grid gap-y-3 pb-2"
      >
        <text-input
          label="First Name"
          v-model="selected.firstName"
        />
        <text-input
          label="Last Name"
          v-model="selected.lastName"
        />
        <text-input
          label="Street Address"
          v-model="selected.address"
        />
        <text-input
          label="Apt/Suite"
          v-model="selected.apt"
        />
        <text-input
          label="City"
          v-model="selected.city"
        />
        <div class="grid grid-cols-2 gap-x-3">
          <text-input
            label="State"
            v-model="selected.state"
          />
          <text-input
            label="Zipcode"
            v-model="selected.zip"
          />
        </div>
        <checkbox-input
          :input-value="'Yes'"
          :value="checkboxSelected"
          @input="handleCheckboxInput"
          :transparent="true"
        >
          My billing zip code is the same as my shipping zip code.
        </checkbox-input>
        <common-btn
          text="Continue"
          @click="nextStage"
          :disabled="Object.values(selected).some(item => !item)"
        />
      </div>
    </div>
    <div class="form">
      <div class="flex items-center py-5">
        <div
          class="
          mr-3 text-sm font-semibold text-white flex items-center
          justify-center w-6 h-6 rounded-full
"
          :class="currentStage === 2 ? 'bg-green-n-black': 'bg-grey-medium'"
        >
          2
        </div>
        <div class="font-semibold">Add Payment Method</div>
      </div>
      <div
        v-if="currentStage === 2"
        class="grid gap-y-3 pb-5"
      >
        <div class="flex space-x-1">
          <img src="@/assets/img/misc/mastercard.png" width="38px" alt="mastercard">
          <img src="@/assets/img/misc/visa.png" width="38px" alt="visa">
          <img src="@/assets/img/misc/american_express.png" width="38px" alt="american_express">
          <img src="@/assets/img/misc/discover.png" width="38px" alt="discover">
        </div>
        <div class="relative">
          <text-input
            label="Card Number"
            v-model="paymentData.cardNumber"
          />
          <img class="absolute right-5 top-1/2 transform -translate-y-1/2" width="14px" src="@/assets/img/icons/lock.png" alt="lock">
        </div>
        <div class="grid grid-cols-2 gap-x-3">
          <text-input
            label="Exp. Month"
            v-model="paymentData.expMonth"
          />
          <text-input
            label="Exp. Year"
            v-model="paymentData.expYear"
          />
        </div>
        <text-input
          label="CCV"
          v-model="paymentData.CCV"
        />
        <common-btn
          class="mb-2"
          text="Proceed To Final Step"
          @click="nextStage"
          :disabled="Object.values(paymentData).some(item => !item)"
        />
        <p class="text-xs mb-2">By clicking “Proceed To Final Step”, you agree that you are at least 18 years or older and that if prescribed, you are purchasing a subscription and will be charged {{ appliedPromo ? '$77.99' : '$87.99' }} for your first shipment and {{ appliedPromo ? '$77.99' : '$87.99' }} thereafter until you cancel or your prescription expires. You can cancel your subsciption at any time by contacting customer service at (866) 483-8644 or via email at support@Nava MD.com</p>
        <div class="grid">
          <div class="flex space-x-3 items-center">
            <img src="@/assets/img/misc/shipping.png" alt="shipping" width="60px">
            <div>Free priority shipping</div>
          </div>
          <div class="flex space-x-3 items-center">
            <img src="@/assets/img/misc/updates.png" alt="updates" width="60px">
            <div>Ongoing support from your doctor</div>
          </div>
        </div>
      </div>
    </div>

    <SecurityFooter class="py-8"/>
  </div>
</template>

<script>
import SecurityFooter from "@/components/misc/SecurityFooter";
import {answersMixin, checkboxMixin, mainDataMixin} from "@/utils/mixins";

const VALID_PROMOS = [
  'BIRTHDAY'
]

export default {
  name: "Checkout",
  mixins: [mainDataMixin, answersMixin, checkboxMixin],
  components: {SecurityFooter},
  watch: {
    selected: {
      handler(newVal) {
        this.setAnswer(this.answersKeys.CHECKOUT, newVal, 'shippingInfo')
      },
      deep: true
    }
  },
  data() {
    return {
      selected: {
        firstName: '',
        lastName: '',
        address: '',
        apt: '',
        city: '',
        state: '',
        zip: ''
      },
      paymentData: {
        cardNumber: '',
        expMonth: '',
        expYear: '',
        CCV: '',
      },
      appliedPromo: null,
      isEnteringPromo: false,
      enteredPromo: null,
      currentStage: 1,
      maxStages: 2,
      checkHandler: newVal => this.setAnswer(this.answersKeys.CHECKOUT, newVal, 'zipCodeSameAsShipping')
    }
  },
  mounted() {
    this.selected.firstName = this.userFirstName
    this.selected.lastName = this.userLastName
  },
  methods: {
    applyPromo() {
      if (this.enteredPromo) {
        if (VALID_PROMOS.includes(this.enteredPromo.toUpperCase())) {
          this.appliedPromo = this.enteredPromo.toUpperCase()
        }
      }
      this.isEnteringPromo = false
    },
    nextStage() {
      if (this.currentStage === this.maxStages) {
        this.$emit('nextStage')
      } else {
        this.currentStage++
      }
    }
  }
}
</script>

<style scoped>
.item {
  @apply flex justify-between items-center py-5
}

.item:not(:last-child) {
  @apply border-b border-grey-darker;
}

.old-price {
  @apply line-through text-grey-medium mr-2;
}

.price {
  @apply font-semibold;
}

.form {
  @apply bg-white rounded-lg px-3
}
</style>
